/**
 * Enumeration that represents transaction propagation behaviors for use with the see {@link Transactional} decorator.
 */
export var PropagationType;
(function (PropagationType) {
    /**
     * Support a current transaction, throw an exception if none exists.
     */
    PropagationType["MANDATORY"] = "MANDATORY";
    /**
     * Execute non-transactionally, suspend the current transaction if one exists.
     */
    PropagationType["NOT_SUPPORTED"] = "NOT_SUPPORTED";
    /**
     * Support a current transaction, create a new one if none exists.
     */
    PropagationType["REQUIRED"] = "REQUIRED";
    /**
     * Support a current transaction, execute non-transactionally if none exists.
     */
    PropagationType["SUPPORTS"] = "SUPPORTS";
})(PropagationType || (PropagationType = {}));
//# sourceMappingURL=propagation.types.js.map